IdeaModel (Gradle API 4.8)
Date: 2018-06-04

org.gradle.plugins.ide.idea.model

## Class IdeaModel

- java.lang.Object
- - org.gradle.plugins.ide.idea.model.IdeaModel

-     public class IdeaModel
      extends Object

  DSL-friendly model of the IDEA project information. First point of entry when it comes to customizing the IDEA generation.

  See the examples in docs for `IdeaModule` or `IdeaProject`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IdeaModel()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IdeaModule` | `getModule()` Configures IDEA module information.
    `IdeaProject` | `getProject()` Configures IDEA project information.
    `String` | `getTargetVersion()` Configures the target IDEA version.
    `IdeaWorkspace` | `getWorkspace()` Configures IDEA workspace information.
    `void` | `module(Action<? super IdeaModule> action)` Configures IDEA module information.
    `void` | `module(Closure closure)` Configures IDEA module information.
    `void` | `pathVariables(Map<String,File> pathVariables)` Adds path variables to be used for replacing absolute paths in resulting files (*.iml, etc.).
    `void` | `project(Action<? super IdeaProject> action)` Configures IDEA project information.
    `void` | `project(Closure closure)` Configures IDEA project information.
    `void` | `setModule(IdeaModule module)`
    `void` | `setProject(IdeaProject project)`
    `void` | `setTargetVersion(String targetVersion)`
    `void` | `setWorkspace(IdeaWorkspace workspace)`
    `void` | `workspace(Action<? super IdeaWorkspace> action)` Configures IDEA workspace information.
    `void` | `workspace(Closure closure)` Configures IDEA workspace information.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IdeaModel

          public IdeaModel()

  - ### Method Detail

    - #### getModule

          public IdeaModule getModule()

      Configures IDEA module information.

      For examples see docs for `IdeaModule`.

    - #### setModule

          public void setModule(IdeaModule module)

    - #### getProject

          public IdeaProject getProject()

      Configures IDEA project information.

      For examples see docs for `IdeaProject`.

    - #### setProject

          public void setProject(IdeaProject project)

    - #### getWorkspace

          public IdeaWorkspace getWorkspace()

      Configures IDEA workspace information.

      For examples see docs for `IdeaWorkspace`.

    - #### setWorkspace

          public void setWorkspace(IdeaWorkspace workspace)

    - #### getTargetVersion

          public String getTargetVersion()

      Configures the target IDEA version.

    - #### setTargetVersion

          public void setTargetVersion(String targetVersion)

    - #### module

          public void module(Closure closure)

      Configures IDEA module information.

      For examples see docs for `IdeaModule`.

    - #### module

          public void module(Action<? super IdeaModule> action)

      Configures IDEA module information.

      For examples see docs for `IdeaModule`.

      Since:
        3.5

    - #### project

          public void project(Closure closure)

      Configures IDEA project information.

      For examples see docs for `IdeaProject`.

    - #### project

          public void project(Action<? super IdeaProject> action)

      Configures IDEA project information.

      For examples see docs for `IdeaProject`.

      Since:
        3.5

    - #### workspace

          public void workspace(Closure closure)

      Configures IDEA workspace information.

      For examples see docs for `IdeaWorkspace`.

    - #### workspace

          public void workspace(Action<? super IdeaWorkspace> action)

      Configures IDEA workspace information.

      For examples see docs for `IdeaWorkspace`.

      Since:
        3.5

    - #### pathVariables

          public void pathVariables(Map<String,File> pathVariables)

      Adds path variables to be used for replacing absolute paths in resulting files (*.iml, etc.).

      For example see docs for `IdeaModule`.

      Parameters:
        `pathVariables` - A map with String->File pairs.